#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define M 2
#define N 4

int hist[5];
int allstate[5][4] =
{
{4,0,1,5},
{3,1,2,4},
{2,2,3,3},
{1,3,4,2},
{0,4,5,1}
};

void v_add(int *v1, int *v2, int n)
{
	int i;

	for (i = 0; i < n; i++)
		v1[i] += v2[i];
}

void v_show(int *v, int n)
{
	int i;

	for (i = 0; i < n; i++)
		printf("%3d ", v[i]);	
	printf("\n");
}

double prob_r(int *y, int *z, int n)
{
	int i;	
	double r;

	r = 1;
	for (i = 0; i < n; i++)
		if (z[i] == 1) {
			r /= (y[i] + 1);
		} else if (z[i] == -1) {
			r *= y[i];
		}
	return r;
}

int v_cmp(int *v1, int *v2, int n)
{
	int i;

	for (i = 0; i < n; i++)
		if (v1[i] - v2[i] != 0)
			return v1[i] - v2[i];
	return 0;
}

void hist_count(int *v, int n)
{
	int i,j;

	for (i = 0; i < 5; i++) 
		if (v_cmp(v, allstate[i], n) == 0) {
			hist[i]++;
			return;
		}
}

int main(int argc, char *argv[])
{
	int i, j;
	int seed = 0;
	int n = 10000;
	double r;
	double rr;
	int markov_b[M][N] = {
		{1,-1,-1,1},
		{-1,1,1,-1}
	};
	int state[N] = {2,2,3,3};

	if (argc >= 2) {
		seed = atoi(argv[1]);	
	} 
	if (argc >= 3) {
		n = atoi(argv[2]);	
	} 

	srand(seed);

	/* burn-in */
	for (i = 0; i < n; i++) {
		j = (int)(M * (rand()/(RAND_MAX + 1.0)));
		r = prob_r(state, markov_b[j], N);	
		rr = (double)rand()/RAND_MAX;	
		if (r > rr)
			v_add(state, markov_b[j], N);
	}

	for (i = 0; i < n; i++) {
		j = (int)(M * (rand()/(RAND_MAX + 1.0)));
		r = prob_r(state, markov_b[j], N);	
		rr = (double)rand()/RAND_MAX;	
		if (r > rr)
			v_add(state, markov_b[j], N);
		v_show(state, N);
		hist_count(state, N);
	}

	for (i = 0; i < 5; i++)
		printf("hist[%d] : %d(%lf)\n", i, hist[i], (double)hist[i]/n);

	return 0;
}
